-- ******************************************************************
-- ******************************************************************
-- **                         MorgBid                              **
-- ******************************************************************
-- ******************************************************************
--
--  Most of this code is Fryguy's:) Thanks for your hard work:)
--

MorgBid = {}


function MorgBid:Enable()
	-- initialize the loot frames
	self.frames = { }
	self.nextframeid = 1
	self.order = 1
	self.version = "2.2"
	
	-- set up the event frame
	self.frame = CreateFrame('Frame', nil, WorldFrame)
	self.frame:SetScript('OnEvent', function() self:OnEvent() end)
	self.frame:RegisterEvent("CHAT_MSG_ADDON")
end

function MorgBid:CreateFrame()
	-- try to reuse an older one if we can
	for i,v in pairs(self.frames) do
		if not v.used then
			self.frames[i].used = true
			self.frames[i].order = self.order
			self.order = self.order + 1
			v.frame:Show()
			return v.frame
		end
	end

	-- we didn't get a frame to reuse, so make a new one
    local f = CreateFrame("Button", "MorgBidFrame"..self.nextframeid, WorldFrame)
    f:EnableMouse(true)
    f:SetFrameStrata("DIALOG")
    f:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp", "Button4Up", "Button5Up")
    --f:SetScript("OnEnter", function() self:OnEnter() end)
    --f:SetScript("OnLeave", function() GameTooltip:Hide() end)
    --f:SetScript("OnClick", function() self:OnClick() end)
	
	f.icon = CreateFrame("Button", "MorgBidIcon", f)
	f.icon:SetWidth(32)
	f.icon:SetHeight(32)
	f.icon:ClearAllPoints()
	f.icon:SetPoint("TOPLEFT", f, "TOPLEFT", 5, -5)
	--f.icon:SetNormalTexture("Interface\\Icons\\INV_Enchant_ShardNexusLarge")
	--f.icon:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Highlight")
	f.icon:SetScript("OnEnter", function()
		local item = "item:" .. self.frames[this:GetParent():GetID()].item .. ":0:0:0"
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
		GameTooltip:SetHyperlink(item);
		CursorUpdate();
	end)
	f.icon:SetScript("OnLeave", function() GameTooltip:Hide() end)
	f.icon:Show()
	
	f.name = f:CreateFontString(nil, "OVERLAY")
	f.name:SetFontObject(GameFontNormalSmall)
	f.name:SetJustifyH("LEFT")
	f.name:SetWidth(200)
	f.name:SetHeight(20)
	f.name:ClearAllPoints()
	f.name:SetPoint("LEFT", f.icon, "RIGHT", 10, 5)
	
	f.subname = f:CreateFontString(nil, "OVERLAY")
	f.subname:SetFontObject(GameFontHighlightSmall)
	f.subname:SetJustifyH("LEFT")
	f.subname:SetWidth(200)
	f.subname:SetHeight(20)
	f.subname:ClearAllPoints()
	f.subname:SetPoint("LEFT", f.icon, "RIGHT", 10, -5)
	
	f.passbutton = CreateFrame("Button", "MorgBidPassButton", f)
	f.passbutton:SetWidth(32)
	f.passbutton:SetHeight(32)
	f.passbutton:ClearAllPoints()
	f.passbutton:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -5, 4)
	f.passbutton:SetNormalTexture("Interface\\Icons\\INV_Enchant_ShardNexusLarge")
	f.passbutton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Highlight")
	f.passbutton:SetScript("OnClick", function() self:HandleDialogAction(this:GetParent(), "PASS") end)
	f.passbutton:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT")
		GameTooltip:SetText("Pass.\nUse this option if you do not need this item")
	end)
	f.passbutton:SetScript("OnLeave", function() GameTooltip:Hide() end)
	f.passbutton:Show()

	f.takebutton = CreateFrame("Button", "MorgBidTakeButton", f)
	f.takebutton:SetWidth(32)
	f.takebutton:SetHeight(32)
	f.takebutton:ClearAllPoints()
	f.takebutton:SetPoint("RIGHT", f.passbutton, "LEFT", -10, 0)
	f.takebutton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Up")
	f.takebutton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Highlight")
	f.takebutton:SetScript("OnClick", function() self:HandleDialogAction(this:GetParent(), "TAKE") end)
	f.takebutton:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT")
		GameTooltip:SetText("Take.\nUse this option if you are able to take this\nitem, but do not necessarily want it or\nwould prefer someone else take it first.\nAlternatively use this button if this is an\noff-spec item (for example dps gear for\nhealers) \nor you have ALREADY received loot.")
	end)
	f.takebutton:SetScript("OnLeave", function() GameTooltip:Hide() end)
	f.takebutton:Show()
	
	f.needbutton = CreateFrame("Button", "MorgBidNeedButton", f)
	f.needbutton:SetWidth(32)
	f.needbutton:SetHeight(32)
	f.needbutton:ClearAllPoints()
	f.needbutton:SetPoint("RIGHT", f.takebutton, "LEFT", -10, 0)
	f.needbutton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Up")
	f.needbutton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Highlight")
	f.needbutton:SetScript("OnClick", function() self:HandleDialogAction(this:GetParent(), "NEED") end)
	f.needbutton:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT")
		GameTooltip:SetText("Need.\nUse this option if you want this item.")
	end)
	f.needbutton:SetScript("OnLeave", function() GameTooltip:Hide() end)
	f.needbutton:Show()
	
	f:SetBackdrop({ bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16, edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16, insets = { left = 3, right = 3, top = 3, bottom = 3 } })
	f:SetBackdropColor(.25, .25, .25, .75)
	f:SetBackdropBorderColor(1, 1, 1, 1)
	
	f:SetWidth(200) f:SetHeight(75)
	f:ClearAllPoints()
	f:SetPoint("BOTTOM", WorldFrame, "BOTTOM", 0, 150)
    f:SetID(self.nextframeid)
		
	self.frames[self.nextframeid] = { used = true, frame = f, order = self.order }
	self.order = self.order + 1	
	self.nextframeid = self.nextframeid + 1
	
	return f
end

function MorgBid:AddItemDialog(item, points)
	local f = self:CreateFrame()

	local sName, sLink, iQuality, _, iLevel, sType, sSubType, iCount, iLoc, iTexture = GetItemInfo(item)
	f.icon:SetNormalTexture(iTexture)
	f.name:SetText(sName)
	if points then
		f.subname:SetText(points.." points")
		f.subname:Show()
	else
		f.subname:Hide()
	end
	self:SortDialogs()
	
	self.frames[f:GetID()].item = item
end

function MorgBid:HandleDialogAction(frame, action)
	local sf = self.frames[frame:GetID()]
	sf.used = false
	sf.frame:Hide()
	self:SortDialogs()
	SendAddonMessage("MORGBID", action.." "..sf.item,"RAID")
	DEFAULT_CHAT_FRAME:AddMessage("Action: "..action.." on item "..sf.item)
end

function MorgBid:SortDialogs()
	-- this is horribly inefficient. sorry
	local last = 0
	local min
	local ct = 0
	
	repeat
		min = nil
		for i,v in pairs(self.frames) do
			if v.used == true and v.order > last and (not min or v.order < min.order) then
				min = v
			end
		end
		if min ~= nil then
			min.frame:ClearAllPoints()
			min.frame:SetPoint("BOTTOM", WorldFrame, "BOTTOM", 0, 200 + ct*80)
			last = min.order			
		end		
		ct = ct + 1
	until min == nil
end

function MorgBid:OnEvent()
	local prefix, message, type, sender = arg1, arg2, arg3, arg4
	if prefix == "MORGBID" then
		local args = {self:Explode(message, " ")}
		if args[1] == "QUERY" then
			local item, points = args[2], args[3]
			if args[4] == UnitName("player") then self:AddItemDialog(item, points) return end
    elseif args[1] == "CHECK" then
    	SendAddonMessage("MORGBID", "REPLY "..UnitName("player").." "..self.version,"RAID")
    end
	end
end



function MorgBid:Disable()
end

function MorgBid:Split(string, sep)
	if (not string) then error("Bad String", 2)     end
	local x = strfind(string , sep) or 0
	return (tonumber(strsub(string, 1, x-1)) or strsub(string, 1, x-1)), (tonumber(strsub(string, x+1)) or strsub(string, x+1))
end
function MorgBid:Explode(string, sep)
	if (not string) then return nil end
	local a, b = self:Split(string, sep)
	if (not b or b == "") then return a; end
	if (not strfind(b or "", sep)) then return a, b; end
	return a, self:Explode(b, sep)
end 

MorgBid:Enable()
